# coding: utf-8

"""
    AdInsightService

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from openapi_client.models.adinsight.device_criterion import DeviceCriterion
from openapi_client.models.adinsight.language_criterion import LanguageCriterion
from openapi_client.models.adinsight.location_criterion import LocationCriterion
from openapi_client.models.adinsight.network_criterion import NetworkCriterion
from openapi_client.models.adinsight.network_type import NetworkType
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

Criterion_ONE_OF_SCHEMAS = ["DeviceCriterion", "LanguageCriterion", "LocationCriterion", "NetworkCriterion"]

class Criterion(BaseModel):
    """
    Criterion
    """
    # data type: DeviceCriterion
    oneof_schema_device_criterion_validator: Optional[DeviceCriterion] = None
    # data type: LanguageCriterion
    oneof_schema_language_criterion_validator: Optional[LanguageCriterion] = None
    # data type: LocationCriterion
    oneof_schema_location_criterion_validator: Optional[LocationCriterion] = None
    # data type: NetworkCriterion
    oneof_schema_network_criterion_validator: Optional[NetworkCriterion] = None
    actual_instance: Optional[Union[DeviceCriterion, LanguageCriterion, LocationCriterion, NetworkCriterion]] = None
    one_of_schemas: Set[str] = { "DeviceCriterion", "LanguageCriterion", "LocationCriterion", "NetworkCriterion" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )

    discriminator_value_class_map: Dict[str, str] = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        if v is None:
            return v

        instance = Criterion.model_construct()
        error_messages = []
        match = 0
        # validate data type: DeviceCriterion
        if not isinstance(v, DeviceCriterion):
            error_messages.append(f"Error! Input type `{type(v)}` is not `DeviceCriterion`")
        else:
            match += 1
        # validate data type: LanguageCriterion
        if not isinstance(v, LanguageCriterion):
            error_messages.append(f"Error! Input type `{type(v)}` is not `LanguageCriterion`")
        else:
            match += 1
        # validate data type: LocationCriterion
        if not isinstance(v, LocationCriterion):
            error_messages.append(f"Error! Input type `{type(v)}` is not `LocationCriterion`")
        else:
            match += 1
        # validate data type: NetworkCriterion
        if not isinstance(v, NetworkCriterion):
            error_messages.append(f"Error! Input type `{type(v)}` is not `NetworkCriterion`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in Criterion with oneOf schemas: DeviceCriterion, LanguageCriterion, LocationCriterion, NetworkCriterion. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in Criterion with oneOf schemas: DeviceCriterion, LanguageCriterion, LocationCriterion, NetworkCriterion. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: Optional[str]) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        if json_str is None:
            return instance

        error_messages = []
        match = 0

        # use oneOf discriminator to lookup the data type
        _data_type = json.loads(json_str).get("Type")
        if not _data_type:
            raise ValueError("Failed to lookup data type from the field `Type` in the input.")

		# check if data type is `DeviceCriterion`
        if _data_type == "DeviceCriterion":
            instance.actual_instance = DeviceCriterion.from_json(json_str)
            return instance
			
		# check if data type is `LanguageCriterion`
        if _data_type == "LanguageCriterion":
            instance.actual_instance = LanguageCriterion.from_json(json_str)
            return instance
			
		# check if data type is `LocationCriterion`
        if _data_type == "LocationCriterion":
            instance.actual_instance = LocationCriterion.from_json(json_str)
            return instance
			
		# check if data type is `NetworkCriterion`
        if _data_type == "NetworkCriterion":
            instance.actual_instance = NetworkCriterion.from_json(json_str)
            return instance
			

        # deserialize data into DeviceCriterion
        try:
            instance.actual_instance = DeviceCriterion.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into LanguageCriterion
        try:
            instance.actual_instance = LanguageCriterion.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into LocationCriterion
        try:
            instance.actual_instance = LocationCriterion.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into NetworkCriterion
        try:
            instance.actual_instance = NetworkCriterion.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into Criterion with oneOf schemas: DeviceCriterion, LanguageCriterion, LocationCriterion, NetworkCriterion. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into Criterion with oneOf schemas: DeviceCriterion, LanguageCriterion, LocationCriterion, NetworkCriterion. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], DeviceCriterion, LanguageCriterion, LocationCriterion, NetworkCriterion]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())

    def __getattr__(self, name):
        """Forward attribute access to actual_instance"""
        if self.actual_instance is not None and hasattr(self.actual_instance, name):
            return getattr(self.actual_instance, name)
        raise AttributeError(f"'{self.__class__.__name__}' object has no attribute '{name}'")

    def __setattr__(self, name, value):
        """Forward attribute setting to actual_instance"""
        if name in ['actual_instance', 'oneof_schema_device_criterion_validator', 'oneof_schema_language_criterion_validator', 'oneof_schema_location_criterion_validator', 'oneof_schema_network_criterion_validator', 'one_of_schemas', 'model_config', 'discriminator_value_class_map']:
            super().__setattr__(name, value)
        elif self.actual_instance is not None and hasattr(self.actual_instance, name):
            setattr(self.actual_instance, name, value)
        else:
            super().__setattr__(name, value)
