# coding: utf-8

"""
    CampaignManagementService

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from openapi_client.models.campaign.number_operator import NumberOperator
from openapi_client.models.campaign.number_rule_item import NumberRuleItem
from openapi_client.models.campaign.string_rule_item import StringRuleItem
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

RuleItem_ONE_OF_SCHEMAS = ["NumberRuleItem", "StringRuleItem"]

class RuleItem(BaseModel):
    """
    RuleItem
    """
    # data type: NumberRuleItem
    oneof_schema_number_rule_item_validator: Optional[NumberRuleItem] = None
    # data type: StringRuleItem
    oneof_schema_string_rule_item_validator: Optional[StringRuleItem] = None
    actual_instance: Optional[Union[NumberRuleItem, StringRuleItem]] = None
    one_of_schemas: Set[str] = { "NumberRuleItem", "StringRuleItem" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )

    discriminator_value_class_map: Dict[str, str] = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        if v is None:
            return v

        instance = RuleItem.model_construct()
        error_messages = []
        match = 0
        # validate data type: NumberRuleItem
        if not isinstance(v, NumberRuleItem):
            error_messages.append(f"Error! Input type `{type(v)}` is not `NumberRuleItem`")
        else:
            match += 1
        # validate data type: StringRuleItem
        if not isinstance(v, StringRuleItem):
            error_messages.append(f"Error! Input type `{type(v)}` is not `StringRuleItem`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in RuleItem with oneOf schemas: NumberRuleItem, StringRuleItem. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in RuleItem with oneOf schemas: NumberRuleItem, StringRuleItem. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: Optional[str]) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        if json_str is None:
            return instance

        error_messages = []
        match = 0

        # use oneOf discriminator to lookup the data type
        _data_type = json.loads(json_str).get("Type")
        if not _data_type:
            raise ValueError("Failed to lookup data type from the field `Type` in the input.")

		# check if data type is `NumberRuleItem`
        if _data_type == "Number":
            instance.actual_instance = NumberRuleItem.from_json(json_str)
            return instance
			
		# check if data type is `StringRuleItem`
        if _data_type == "String":
            instance.actual_instance = StringRuleItem.from_json(json_str)
            return instance
			
		# check if data type is `NumberRuleItem`
        if _data_type == "NumberRuleItem":
            instance.actual_instance = NumberRuleItem.from_json(json_str)
            return instance
			
		# check if data type is `StringRuleItem`
        if _data_type == "StringRuleItem":
            instance.actual_instance = StringRuleItem.from_json(json_str)
            return instance
			

        # deserialize data into NumberRuleItem
        try:
            instance.actual_instance = NumberRuleItem.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into StringRuleItem
        try:
            instance.actual_instance = StringRuleItem.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into RuleItem with oneOf schemas: NumberRuleItem, StringRuleItem. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into RuleItem with oneOf schemas: NumberRuleItem, StringRuleItem. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], NumberRuleItem, StringRuleItem]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())

    def __getattr__(self, name):
        """Forward attribute access to actual_instance"""
        if self.actual_instance is not None and hasattr(self.actual_instance, name):
            return getattr(self.actual_instance, name)
        raise AttributeError(f"'{self.__class__.__name__}' object has no attribute '{name}'")

    def __setattr__(self, name, value):
        """Forward attribute setting to actual_instance"""
        if name in ['actual_instance', 'oneof_schema_number_rule_item_validator', 'oneof_schema_string_rule_item_validator', 'one_of_schemas', 'model_config', 'discriminator_value_class_map']:
            super().__setattr__(name, value)
        elif self.actual_instance is not None and hasattr(self.actual_instance, name):
            setattr(self.actual_instance, name, value)
        else:
            super().__setattr__(name, value)
